'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _HTMLDOMPropertyConfig = require('react/lib/HTMLDOMPropertyConfig');

var _ComponentStyle = require('../models/ComponentStyle');

var _ComponentStyle2 = _interopRequireDefault(_ComponentStyle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (tagName, rules) {
  var isTag = typeof tagName === 'string';
  var componentStyle = new _ComponentStyle2.default(rules);

  var StyledComponent = function (_Component) {
    _inherits(StyledComponent, _Component);

    function StyledComponent() {
      _classCallCheck(this, StyledComponent);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(StyledComponent).apply(this, arguments));
    }

    _createClass(StyledComponent, [{
      key: 'getChildContext',
      value: function getChildContext() {
        return { theme: this.theme };
      }
    }, {
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.componentWillReceiveProps(this.props, this.context);
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(newProps, newContext) {
        this.theme = Object.assign({}, (newContext || {}).theme);
        this.generatedClassName = componentStyle.injectStyles([newProps, this.theme]);
      }
      /* eslint-disable react/prop-types */

    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        var _props = this.props;
        var className = _props.className;
        var children = _props.children;

        // const contextForStyles

        var propsForElement = {};
        Object.keys(this.props).filter(function (propName) {
          return (
            /* Don't pass through non HTML tags through to HTML elements */
            !isTag || _HTMLDOMPropertyConfig.Properties[propName] !== undefined
          );
        }).forEach(function (propName) {
          propsForElement[propName] = _this2.props[propName];
        });
        propsForElement.className = [className, this.generatedClassName].filter(function (x) {
          return x;
        }).join(' ');

        return (0, _react.createElement)(tagName, propsForElement, children);
      }
    }]);

    return StyledComponent;
  }(_react.Component);

  StyledComponent.displayName = isTag ? 'styled.' + tagName : 'Styled(' + tagName.displayName + ')';
  StyledComponent.childContextTypes = {
    theme: _react.PropTypes.object
  };
  StyledComponent.contextTypes = {
    theme: _react.PropTypes.object
  };
  return StyledComponent;
};

module.exports = exports['default'];